# https://curlconverter.com/#python
# https://www.klipper3d.org/API_Server.html
# https://moonraker.readthedocs.io/en/latest/web_api/
# PrusaSlicer -> "C:\Program Files\Python38\python.exe" "C:\PS_PP_Scripte\sendendtime.py";       kgolger_2022_06_18

import requests
import sys
import time
import json

try:

	sourcefile=sys.argv[1]
	#sourcefile="C:\PS_PP_Scripte\Test.gcode"
	substring = "Printer is ready"

	print('send gcode to printer\n')
	headers = {
	}
	files = {
		'select': (None, 'false'),
		'print': (None, 'false'),
		'X-Api-Key': '123',
		'file': open(sourcefile, 'rt', encoding='utf-8'),
	}
	response = requests.post('http://192.168.0.15:7125/api/files/local', headers=headers, files=files, timeout=30, verify=True)

	print('calculate endtime, execute endtime.sh, restart firmware\n')
	json_data = {
		'commands': [
			'ENDTIME',
			'RESTART',
			],
	}
	response = requests.post('http://192.168.0.15:7125/api/printer/command', headers=headers, json=json_data)

	print('check printerstatus\n')
	response = requests.get('http://192.168.0.15:7125/printer/info')
	fullstring = json.dumps(response.json())
	while fullstring == None or substring not in fullstring:
		print('Printer not ready!')
		print('Try connecting...\n')
		time.sleep(3)
		response = requests.get('http://192.168.0.15:7125/printer/info')
		fullstring = json.dumps(response.json())

	print('start print, execute startgcode.sh')
	json_data = {
		'commands': [
			'STARTPRINT',
		],
	}
	send = requests.post('http://192.168.0.15:7125/api/printer/command', headers=headers, json=json_data)
	time.sleep(5)

except:
	fehlermeldung0 = str(sys.exc_info()[0])
	fehlermeldung1 = str(sys.exc_info()[1])
	fehlermeldung2 = str(sys.exc_info()[2])	
	#print fehlermeldung0 + fehlermeldung1 + fehlermeldung2
	fobj_out = open("C:\PS_PP_Scripte\sendendtime.log","a")	# Datei oeffnen zum Schreiben
	from time import *
	lt = localtime()
	Datum = strftime("Datum: %d.%m.%Y", lt)
	Uhrzeit = strftime("Uhrzeit: %H:%M:%S", lt)
	fobj_out.write(Datum + " " + Uhrzeit + " ")	# Zeile in Datei schreiben
	fobj_out.write(fehlermeldung0 + " " + fehlermeldung1 + " " + fehlermeldung2 + "\n")	# Zeile in Datei schreiben
	fobj_out.close()		# Datei schliessen

